#include <cstdio>
#include <vector>
#include "memory.h"
#include <iostream>
using namespace std;

int F[30][30][30][30];
vector<int> A;
vector<int> B;

int Rec(int x1, int x2, int y1, int y2){
    if(x1 > x2 || y1 > y2) return 0;

    bool V[32];
    memset(V, true, 30);
    if(F[x1][x2][y1][y2] == -1){
        for(int i = x1; i <= x2; i++) for(int j = y1; j <= y2; j++) if(A[i] == B[j]){
            V[Rec(x1, i-1, y1, j-1) ^ Rec(i+1, x2, j+1, y2)] = false;
        }
        for(int i = 0; i < 30; i++) if(V[i]) {
            F[x1][x2][y1][y2] = i;
            break;
        }
    }

    return F[x1][x2][y1][y2];
}

int main(){
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    int n, m;
    scanf("%d%d", &n, &m);
    A.resize(n);
    B.resize(m);
    for(int i = 0 ; i < n; i++) scanf("%d", &A[i]);
    for(int i = 0 ; i < m; i++) scanf("%d", &B[i]);

    for(int i = 0; i < n; i++)for(int j = 0; j < n; j++)for(int k = 0; k < m; k++) for(int l = 0; l < m; l++) F[i][j][k][l] = -1;

    if (Rec(0, n-1, 0, m-1) == 0) printf("LOSE\n");
    else printf("WIN\n");

    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) if(A[i] == B[j]){
        if ( (Rec(0, i-1, 0, j-1) ^ Rec(i+1, n-1, j+1, m-1)) == 0) printf("%d %d\n", i, j);
    }

    fclose(stdin);
    fclose(stdout);
    return 0;
}
