#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;

int m, n, a[20], b[20], arr[21][21][21][21];

int main(){
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    cin >> m >> n;
    for(int i = 0; i < m; ++i)
        cin >> a[i];
    for(int i = 0; i < n; ++i)
        cin >> b[i];
    for(int di = 1; di <= m; ++di)
    for(int i = 0; i <= m - di; ++i){
        int i1 = i + di;
        for(int dj = 1; dj <= n; ++dj)
        for(int j = 0; j <= n - dj; ++j){
            int j1 = j + dj;
            bool reached[24];
            memset(reached, 0, sizeof(reached));
            for(int i2 = i; i2 < i1; ++i2)
            for(int j2 = j; j2 < j1; ++j2)
                if(a[i2] == b[j2]){
                    int up_code = arr[i][i2][j][j2];
                    int down_code = arr[i2+1][i1][j2+1][j1];
                    int code = up_code ^ down_code;
                    reached[code] = true;
                }
            for(int code = 0; code < 24; ++code)
                if(!reached[code]){
                    arr[i][i1][j][j1] = code;
                    break;
                }
        }
    }
    if(arr[0][m][0][n] == 0)
        cout << "LOSE" << endl;
    else{
        cout << "WIN" << endl;
        for(int i = 0; i < m; ++i)
        for(int j = 0; j < n; ++j)
            if(a[i] == b[j]){
                int up_code = arr[0][i][0][j];
                int down_code = arr[i+1][m][j+1][n];
                int code = up_code ^ down_code;
                if(code == 0)
                    cout << i << ' ' << j << endl;
            }
    }
}
