/* GCC */
#include <bits/stdc++.h>

using namespace std;
typedef vector <long long> tlong;
int n, p[110];
bool used[110];
int cnt[110];
long long base = 1000 * 1000 * 1000;
tlong total;

tlong comb[110][110];





void print(tlong a){
    printf("%d", a[a.size() -1]);
    for (int i = a.size() - 2; i >= 0; --i)
        printf("%09d", a[i]);
    printf("\n");
}

void operator += (tlong &a, tlong b){
    long long carry = 0;
    for (int i = 0 ; i < max(a.size(), b.size()) || carry; ++i){
        if (a.size() == i) a.push_back(0);
        a[i] += carry;
        if (i < b.size()) a[i] += b[i];
        carry = a[i] >= base;
        if (carry) a[i] -= base;
    }
}
tlong operator *(tlong a, tlong b){
    tlong c;
    c.resize(a.size() + b.size());
    long long carry = 0;
    for (int i = 0; i < a.size(); ++i){
        for (int j = 0; j < b.size(); ++j){
            carry += a[i] * b[j] + c[i + j];
            c[i + j] = carry % base;
            carry/=base;
        }
        int pos = i + b.size();
        while (carry){
            carry += c[pos];
            c[pos] = carry % base;
            carry /= base;
            ++pos;
        }
    }
    while (c.size() > 1 && c.back() == 0) c.pop_back();
    return c;
}
tlong fac(int n){
    tlong res;
    if (n == 1){
        res.push_back(1);
        return res;
    }
    tlong temp;
    temp.push_back(n);
    return fac(n - 2) * temp;
}
tlong po(long long a, long long b){
    tlong res;
    if (b == 0){
        res.push_back(1);
        return res;
    }
    if (b == 0){
        res.push_back(a);
        return res;
    }
    tlong temp = po(a, b / 2);
    res = temp * temp;
    tlong cur;
    cur.push_back(a);
    if (b % 2) res = res * cur;
    return res;
}
void c(){
    comb[0][0].push_back(1);
    for (int i = 1; i <= 100; ++i){
        comb[i][0].push_back(1);
        for (int j = 1; j < i; ++j){
            comb[i][j] = comb[i - 1][j - 1];
            comb[i][j] += comb[i - 1][j];
        }
        comb[i][i].push_back(1);
    }
}
int main()
{
    total.push_back(1);
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);
    c();
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i)
        scanf("%d", &p[i]);
    for (int i = 1; i <= n; ++i)
        if (!used[i]){
            int j = i;
            int k = 0;
            while (!used[j]){
                used[j] = 1;
                j = p[j];
                ++k;
            }
            cnt[k]++;
        }
    for (int i = 1; i < 110; ++i)
        if (cnt[i]){
            if (i % 2 == 0){
                if (cnt[i] % 2){
                    printf("0\n");return 0;
                }
                total = total * po(i, cnt[i] / 2) * fac(cnt[i] - 1);
            }
            else {
                tlong temp;
                temp.push_back(1);
                for (int j = 1; j <= cnt[i] / 2; ++j){
                    temp += comb[cnt[i]][2 * j] * po(i, j) * fac(2 * j - 1);
                }
                total = total * temp;
            }
        }
    print(total);
    return 0;
}
