/* GCC */
#include <iostream>
#include <set>
#include <vector>
#include <cstdio>

using namespace std;

typedef set<long>::iterator si;
typedef pair<long,long> pll;

long dp[22][22][22][22],lc[22],rc[22];
vector <pll> ans;
long n,m;

long mex(set <long> s){
    long m = 0;
    for(si i = s.begin();i != s.end();i++)
        if (*i == m) m++;
    else break;
    return m;
}

long g(long i1,long i2,long j1,long j2,bool out = false)
{
    if (dp[i1][i2][j1][j2] != -1) return dp[i1][i2][j1][j2];
    if (i1==i2||j1==j2) return dp[i1][i2][j1][j2] = 0;
    set <long> s;
    for (long i = i1;i < i2;i++)
        for (long j = j1;j < j2;j++)
        if (lc[i] == rc[j]) {
            long temp = g(i1,i,j1,j)^g(i+1,i2,j+1,j2);
            s.insert(temp);
            if (temp == 0&&out) ans.push_back(pll(i,j));
        }
    return dp[i1][i2][j1][j2] = mex(s);
}


using namespace std;
int main()
{
    freopen("game.in","r",stdin);
    freopen("game.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
   for (long i = 0;i < 22;i++)
    for (long j = 0;j < 22;j++)
      for (long k = 0;k < 22;k++)
       for (long o = 0;o < 22;o++)
       dp[i][k][o][j] = -1;
   cin>>n>>m;
   for (long i = 0;i < n;i++)
    cin>>lc[i];
   for(long j = 0;j < m;j++)
    cin>>rc[j];
   if (!g(0,n,0,m,true)) {
        cout<<"LOSE"<<'\n';
        return 0;
   }
   cout<<"WIN"<<'\n';
   for (long i = 0;i < ans.size();i++)
    cout<<ans[i].first<<' '<<ans[i].second<<'\n';

    return 0;
}
