#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int n, a, b;

int prev (int p, int k){
    if (p < 1 + (k*a)/b) return (2*p-1);
    if (p < k) return (2*p+1);
    if (p < k + (k*a)/b) return (2*(p-k+1));
    return (2*(p-k+1) + 2);
}

pair <int, int> last(int k){
    if (k == 1) return make_pair(1, 2);

    pair <int, int> ans = last(k-1);

    return make_pair(prev(ans.first, k), prev(ans.second, k));
}

int main(){
    freopen("cards.in", "r", stdin);
    freopen("cards.out", "w", stdout);

    scanf("%d%d%d", &n, &a, &b);

    pair <int, int> ans = last(n);

    printf("%d %d\n", ans.first, ans.second);

    return 0;
}
