#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int Poz[30][30][30][30];
vector <int> Seq1, Seq2;
int n, m;

int Rec(int x1, int x2, int y1, int y2){
    if ((x1 > x2) || (y1 > y2)) return 0;

    vector <bool> V(32, true);

    if (Poz[x1][x2][y1][y2] == -1){
        for (int i = x1; i <= x2; i++) for (int j = y1; j <= y2; j++) if (Seq1[i] == Seq2[j]){
            V [Rec(x1, i-1, y1, j-1) ^ Rec(i+1, x2, j+1, y2)] = false;
        }

        for (int i = 0; i<32; i++) if (V[i]) {Poz[x1][x2][y1][y2] = i; break;}
    }

    return Poz[x1][x2][y1][y2];
}

int main(){
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    scanf("%d%d", &n, &m);
    Seq1.resize(n);
    Seq2.resize(m);

    for (int i = 0; i<n; i++) scanf("%d", &Seq1[i]);
    for (int i = 0; i<m; i++) scanf("%d", &Seq2[i]);

    for (int i = 0; i<30; i++) for (int j = 0; j<30; j++) for (int l = 0; l<30; l++) for (int k = 0; k<30; k++) Poz[i][j][l][k] = -1;

    if (Rec(0, n - 1, 0, m - 1) == 0) printf("LOSE\n"); else printf("WIN\n");

    for (int i = 0; i<n; i++) for (int j = 0; j<m; j++) if (Seq1[i] == Seq2[j]){
        if ((Rec(0, i-1, 0, j-1) ^ Rec(i+1, n-1, j+1, m-1)) == 0) printf("%d %d\n", i, j);
    }

    return 0;
}
