#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int main(){
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);

    long long ans = 0;
    vector <int> Seq;
    vector <vector <int> > Cycle;
    vector <bool> Vis;
    int n;

    scanf("%d", &n);
    Seq.resize(n);

    for (int i = 0; i<n; i++) {
        scanf("%d", &Seq[i]);
        Seq[i]--;
    }

    Vis.assign(n, true);
    for (int i = 0; i<n; i++) if (Vis[i]){
        Cycle.push_back(vector <int> ());
        int j = Seq[i];
        while (j != i){
            Vis[j] = false;
            Cycle.back().push_back(j);
            j = Seq[j];
        }
        Vis[i] = false;
        Cycle.back().push_back(i);
    }

    vector <int> Kol(n+1, 0);
    for (int i = 0; i<Cycle.size(); i++) Kol[Cycle[i].size()]++;

    for (int i = 0; i <= n; i++) if ((i%2 == 0) && (Kol[i]%2 != 0)){
        printf("0\n");
        return 0;
    }

    vector <int> Rez1(n), Rez2(n);
    for (int i = 0; i<n; i++) Rez1[i] = i;

    while (next_permutation(Rez1.begin(), Rez1.end())){
        for (int i = 0; i<n; i++) Rez2[i] = Rez1[Rez1[i]];
        if (Rez2 == Seq) {
            ans++;
        }
    }

    printf("%I64d\n", ans);


    return 0;
}
