#include <bits/stdc++.h>

using namespace std;

bool color[2][20];
int dp[20][20][20][20];

int f(int l1, int r1, int l2, int r2) {
    if(l1 > r1 || l2 > r2)
        return 0;
    if(dp[l1][r1][l2][r2] != -1)
        return dp[l1][r1][l2][r2];

    bool used[2000] = {0};
    int hV;
    for(int i = l1;i <= r1;++i)
    for(int j = l2;j <= r2;++j)
    if(color[0][i] == color[1][j]) {
        hV = f(l1, i-1, l2, j-1) ^ f(i+1, r1, j+1, r2);
        used[hV] = 1;
    }

    int k = 0;
    while(used[k]) k++;
    return  dp[l1][r1][l2][r2] = k;
}

void answer(int n, int m) {
    for(int i = 0;i < n;++i)
    for(int j = 0;j < m;++j)
    if(color[0][i] == color[1][j]) {
        int hV = f(0, i-1, 0, j-1) ^ f(i+1, n-1, j+1, m-1);
        if(hV == 0)
            cout << i << ' ' << j << '\n';
    }
}

int main()
{
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    int m, n;
    cin >> m >> n;

    for(int i = 0;i < m;++i)
        cin >> color[0][i];
    for(int i = 0;i < n;++i)
        cin >> color[1][i];

    for(int i1 = 0;i1 < 20;++i1)
    for(int i2 = 0;i2 < 20;++i2)
    for(int i3 = 0;i3 < 20;++i3)
    for(int i4 = 0;i4 < 20;++i4)
        dp[i1][i2][i3][i4] = -1;

    if(f(0, m-1, 0, n-1)) {
        cout << "WIN\n";
        answer(m, n);
    }
    else
        cout << "LOSE\n";
    return 0;
}
