/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
typedef set<int>::iterator sit;
const lint inf = 1000*1000*1000 + 7;

int dp[21][21][21][21];
char lefter[21], righter[21];
bool flag = false;

int mex(const set<int>& s) {
    int m = 0;
    for (sit it = s.begin(); it != s.end(); ++it)
        if (*it == m) m++;
        else break;
    return m;
}

int get(int i1, int i2, int j1, int j2, bool out=false) {
    if (dp[i1][i2][j1][j2] != -1) return dp[i1][i2][j1][j2];
    if (i1 == i2 || j1 == j2) return dp[i1][i2][j1][j2] = 0;
    set<int> sg;
    for (int i = i1; i < i2; i++) {
        for (int j = j1; j < j2; j++) {
            if (lefter[i] != righter[j]) continue;
            int state = get(i1, i, j1, j)^get(i+1, i2, j+1, j2);
            sg.insert(state);
            if (out && state == 0) {
                if (!flag) {
                    cout << "WIN\n";
                    flag = true;
                }
                cout << i << ' ' << j << '\n';
            }
        }
    }
    return dp[i1][i2][j1][j2] = mex(sg);
}

int main() {

    files(game);

    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    for (int i = 0; i <= 20; i++)
        for (int j = 0; j <= 20; j++)
            for (int k = 0; k <= 20; k++)
                for (int l = 0; l <= 20; l++)
                    dp[i][j][k][l] = -1;

    int l, r;
    cin >> l >> r;
    for (int i = 0; i < l; i++)
        cin >> lefter[i];
    for (int i = 0; i < r; i++)
        cin >> righter[i];

    if (!get(0, l, 0, r, true))
        cout << "LOSE\n";

    return 0;
}
