/* GCC */
#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>

using namespace std;

const long long base = 100000000;

typedef vector <long long> Big;

long cnt[110],a[110];
bool used[110];
long long n;

bool prime(long long a)
{
    if (a <= 1) return 0;
    for (long i = 2;i <= (long)sqrt(a);i++)
        if (a%i == 0) return 0;
    return 1;
}

long long find_pow(long long a,long long b)
{
    unsigned long long pow_a = a,r = 0;
    while(b/pow_a >= 1)
    {
        r += b/pow_a;
        pow_a=pow_a * a;
    }
    return r;
}

unsigned long long bin_pow(long long a,long long b)
{
    if (b == 0) return 1;
    if (b == 1) return a;
    long long temp = bin_pow(a,b/2);
    if (b % 2 == 0) return temp*temp;
    return temp*temp*a;
}

unsigned long long c(long long a,long long b)
{
    unsigned long long ans = 1;
    for(long i = 2;i <= b;i++)
        if (prime(i)){
            ans=ans * bin_pow(i,find_pow(i,b)-find_pow(i,b-a)-find_pow(i,a));
    }
    return ans;
}

unsigned long long faq(long long a)
{
    unsigned long long ans = 1;
    for (long i = 3;i <= a;i+=2)
        ans=ans * i;
    return ans;
}

unsigned long long ans;

int main()
{
    freopen("sleep2.in","r",stdin);
    freopen("sleep2.out ","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    for (long i = 0;i < n+2;i++)
        used[i] = 0;
    for (long i = 1;i <= n;i++)
        cin >> a[i];
    for (long i = 1;i <= n;i++)
        if (!used[i]){
              long k = 0,t = i;
              while(!used[t])
              {
                  used[t] = 1;
                  k++;
                  t = a[t];
              }
              cnt[k]++;
        }
     ans = 1;
     for (long i = 1;i <= n;i++)
        if (cnt[i]){
        unsigned long long temp = 1;
        if (i%2 == 0){
            if (cnt[i]%2 != 0){cout<<0<<'\n';return 0;}
            temp = faq(cnt[i] - 1) * bin_pow(i , cnt[i]/2);
        }
        else{
            for (long j = 1;j <= cnt[i]/2;j++)
                temp += c(2*j,cnt[i]) * bin_pow(i,j) * faq(2*j - 1);
        }
        ans*=temp;
     }
     cout<<ans;
     cout<<'\n';
    return 0;
}
